package main

import (
	"fmt"
	"log"
	"net"
	"ssh-proxy/pkg/logger"
	"ssh-proxy/pkg/proxy"
)

func main() {
	fmt.Println("vim-go")

	laddr, err := net.ResolveTCPAddr("tcp", ":9999")
	if err != nil {
		log.Fatal(err)
	}

	raddr, err := net.ResolveTCPAddr("tcp", "localhost:22")
	if err != nil {
		log.Fatal(err)
	}

	listener, err := net.ListenTCP("tcp", laddr)
	if err != nil {
		log.Fatal(err)
	}

	var connid uint64 = 0
	for {
		conn, err := listener.AcceptTCP()
		if err != nil {
			log.Println(err)
			continue
		}
		connid++
		var p *proxy.Proxy

		p = proxy.New(conn, laddr, raddr)
		p.Nagles = false
		p.OutputHex = true
		p.Log = logger.ColorLogger{
			VeryVerbose: true,
			Verbose:     true,
			Prefix:      fmt.Sprintf("Connection: #%03d ", connid),
			Color:       true,
		}
		go func() {
			err := p.Start()
			if err != nil {
				log.Println("conn err ::: ", err)
			}
		}()
	}
}
